%% Plda grfok az algoritmusokhoz.
%% A vizualitst elsegtend, a grfok bri megtallhatak a sample mappban.

-module(sample).

-export([graph1/0, graph2/0, graph3/0, graph4/0, graph5/0]).

%% Pldagrf, elsdlegesen a mlysgi- s a szlessgi bejrs algoritmushoz.
%% Irnytott, slyozatlan grf.
graph1() ->
    Graph = digraph:new(),
    digraph:add_vertex(Graph, 1),
    digraph:add_vertex(Graph, 2),
    digraph:add_vertex(Graph, 3),
    digraph:add_vertex(Graph, 4),
    digraph:add_vertex(Graph, 5),
    digraph:add_vertex(Graph, 6),
    digraph:add_vertex(Graph, 7),
    digraph:add_vertex(Graph, 8),
    digraph:add_edge(Graph, 1, 2),
    digraph:add_edge(Graph, 1, 3),
    digraph:add_edge(Graph, 1, 4),
    digraph:add_edge(Graph, 2, 5),
    digraph:add_edge(Graph, 2, 6),
    digraph:add_edge(Graph, 3, 2),
    digraph:add_edge(Graph, 3, 4),
    digraph:add_edge(Graph, 3, 6),
    digraph:add_edge(Graph, 4, 6),
    digraph:add_edge(Graph, 4, 7),
    digraph:add_edge(Graph, 5, 8),
    digraph:add_edge(Graph, 6, 7),
    digraph:add_edge(Graph, 6, 8),
    Graph.

%% Pldagrf, elsdlegesen a Dijkstra algoritmushoz.
%% Irnytott, nemnegatvan lslyozott grf.
graph2() ->
    Graph = digraph:new(),
    digraph:add_vertex(Graph, 1),
    digraph:add_vertex(Graph, 2),
    digraph:add_vertex(Graph, 3),
    digraph:add_vertex(Graph, 4),
    digraph:add_vertex(Graph, 5),
    digraph:add_vertex(Graph, 6),
    digraph:add_edge(Graph, 1, 2, 3),
    digraph:add_edge(Graph, 1, 3, 10),
    digraph:add_edge(Graph, 2, 3, 5),
    digraph:add_edge(Graph, 2, 4, 2),
    digraph:add_edge(Graph, 3, 5, 6),
    digraph:add_edge(Graph, 3, 6, 4),
    digraph:add_edge(Graph, 4, 3, 1),
    digraph:add_edge(Graph, 4, 6, 6),
    digraph:add_edge(Graph, 6, 5, 3),
    Graph.

%% Pldagrf, elsdlegesen a Prim algoritmushoz.
%% Irnytatlan, lslyozott grf.
graph3() ->
    Graph = digraph:new(),
    digraph:add_vertex(Graph, 1),
    digraph:add_vertex(Graph, 2),
    digraph:add_vertex(Graph, 3),
    digraph:add_vertex(Graph, 4),
    digraph:add_vertex(Graph, 5),
    digraph:add_vertex(Graph, 6),
    digraph:add_edge(Graph, 1, 2, 3),
    digraph:add_edge(Graph, 1, 3, 10),
    digraph:add_edge(Graph, 2, 1, 3),
    digraph:add_edge(Graph, 2, 3, 5),
    digraph:add_edge(Graph, 2, 4, 2),
    digraph:add_edge(Graph, 3, 1, 10),
    digraph:add_edge(Graph, 3, 2, 5),
    digraph:add_edge(Graph, 3, 4, 1),
    digraph:add_edge(Graph, 3, 5, 6),
    digraph:add_edge(Graph, 3, 6, 4),
    digraph:add_edge(Graph, 4, 2, 2),
    digraph:add_edge(Graph, 4, 3, 1),
    digraph:add_edge(Graph, 4, 6, 6),
    digraph:add_edge(Graph, 5, 3, 6),
    digraph:add_edge(Graph, 5, 6, 3),
    digraph:add_edge(Graph, 6, 5, 3),
    digraph:add_edge(Graph, 6, 3, 4),
    digraph:add_edge(Graph, 6, 4, 6),
    Graph.

%% Pldagrf, elsdlegesen a Bellman-Ford algoritmushoz.
%% Irnytott, negatvan is lslyozott grf.
graph4() ->
    Graph = digraph:new(),
    digraph:add_vertex(Graph, 1),
    digraph:add_vertex(Graph, 2),
    digraph:add_vertex(Graph, 3),
    digraph:add_vertex(Graph, 4),
    digraph:add_vertex(Graph, 5),
    digraph:add_edge(Graph, 1, 2, 5),
    digraph:add_edge(Graph, 1, 3, 8),
    digraph:add_edge(Graph, 1, 4, -4),
    digraph:add_edge(Graph, 2, 1, -2),
    digraph:add_edge(Graph, 3, 2, -3),
    digraph:add_edge(Graph, 3, 4, 9),
    digraph:add_edge(Graph, 4, 2, 7),
    digraph:add_edge(Graph, 5, 1, 6),
    digraph:add_edge(Graph, 5, 3, 7),
    Graph.

%% Pldagrf, esldlegesne a Bellman-Ford algoritmushoz.
%% Irnytott, negatv krt is tartalmaz, lslyozott grf.
graph5() ->
    Graph = digraph:new(),
    digraph:add_vertex(Graph, 1),
    digraph:add_vertex(Graph, 2),
    digraph:add_vertex(Graph, 3),
    digraph:add_vertex(Graph, 4),
    digraph:add_vertex(Graph, 5),
    digraph:add_edge(Graph, 1, 2, 5),
    digraph:add_edge(Graph, 1, 3, 8),
    digraph:add_edge(Graph, 1, 4, -4),
    digraph:add_edge(Graph, 2, 1, -2),
    digraph:add_edge(Graph, 3, 2, -3),
    digraph:add_edge(Graph, 3, 4, 9),
    digraph:add_edge(Graph, 4, 2, 5),
    digraph:add_edge(Graph, 5, 1, 6),
    digraph:add_edge(Graph, 5, 3, 7),
    Graph.
